package pt.moth.dependencies.secondPhase;

import pt.moth.inter.ForwardInterproceduralAnalysis;
import soot.Body;
import soot.SootMethod;
import soot.jimple.InvokeExpr;
import soot.toolkits.graph.BriefUnitGraph;
import soot.toolkits.graph.UnitGraph;

public class InterAnalysis extends ForwardInterproceduralAnalysis<StackLattice> {

	public InterAnalysis() {
		super();
		analyze();
	}


	@Override
	protected StackLattice analyzeMethod(Body activeBody, StackLattice paramValues) {
		UnitGraph g = new BriefUnitGraph(activeBody);
		new IntraAnalysis(g, paramValues, this).getFlowAtEnd();
		return new StackLattice(null);
	}

	@Override
	protected void copy(StackLattice source, StackLattice dest) {
		source.copy(dest);
	}

	@Override
	protected StackLattice defaultParameterValues(SootMethod method) {
		return new StackLattice(null);
	}

	@Override
	protected StackLattice defaultReturnValue(SootMethod method) {
		return new StackLattice(null);
	}

	@Override
	protected StackLattice handleSkippedMethodInvocation(SootMethod callerMethod,
			StackLattice out, InvokeExpr invokeExpr, SootMethod invokedMethod) {
		return (StackLattice)out.clone();
	}

	@Override
	protected void merge(StackLattice in1, StackLattice in2, StackLattice out) {
		in1.union(in2, out);
	}

	@Override
	protected StackLattice newInitialFlow() {
		return new StackLattice(null);
	}

	@Override
	protected void populateParameters(SootMethod callerMethod,
			SootMethod calleeMethod, InvokeExpr invokeExpr, StackLattice out,
			StackLattice parameter) {
		parameter.union(out);
	}

	@Override
	protected boolean shouldAnalyzeMethod(SootMethod method) {
		if (method.getDeclaringClass().isPhantom()) {
			return false;
		}
		else if (!method.hasActiveBody()) {
			return false;
		}
		return true;
	}

}
