package pt.moth.util.variables;

import soot.SootMethod;
/**
 * This class represents a general returned variable.
 * 
 * @author Vasco Pessanha
 * 
 */
public class ReturnVar implements Variable {

	protected String name;
	protected SootMethod method;
	
	public ReturnVar(SootMethod method) {
		this.method = method;
		this.name = method.getName()+".return";
	}
	public String toString() {
		return name;
	}

	public String getName() {
		return name;
	}

	public SootMethod getSootMethod() {
		return method;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((method == null) ? 0 : method.getSignature().hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof ReturnVar))
			return false;
		ReturnVar other = (ReturnVar) obj;
		if (method == null) {
			if (other.method != null)
				return false;
		} else if (!method.equals(other.method))
			return false;
		return true;
	}
	@Override
	public ReturnVar copy() {
		return new ReturnVar(method);
	}

}
